'
' Instances of this class represent redo commands.
'
<Redo()> Public Class RedoCommand
    Implements ICommand

    '
    ' This implementation of DoIt does not actually do anything.
    ' The logic for redo is in the CommandManager class.  A
    ' CommandManager object knows that it is supposed to invoke
    ' its redo logic when it sees an instace of this class
    ' because this class implments the Redo interface.  The Redo
    ' interface is a semantic interface that is used to mark a
    ' class as representing an redo command.
    '
    Public Function DoIt() As Boolean _
        Implements ICommand.DoIt
        ' This method should never be called
        Throw New System.NotImplementedException()
    End Function

    '
    ' This implementation of UndoIt does not actually do
    ' anything.  Redo commands are not undone.  Instead a undo
    ' command is issued.
    '
    Public Function UndoIt() As Boolean _
        Implements ICommand.UndoIt
        ' This method should never be called
        Throw New System.NotImplementedException()
    End Function

End Class 'RedoCommand 
